logf3<-matrix(nrow=length(b0),ncol=length(b1))

y<-wais$senility
x<-wais$wais
n<-length(x)
X<-cbind( rep(1,n), x )

mu.beta<-c(0,0)
theta0<-c(0,0)
eta<-theta0[1]+theta0[2]*x
eta[eta>700]<-700
h<- 1/( (1+exp(-eta))*(1+exp(eta)) )
T<- t(X)%*% diag(h) %*% X

for (x0 in 1:length(b0)){
		for (x1 in 1:length(b1)){
				beta<-as.matrix(c(b0[x0],b1[x1]))
				eta<-beta[1]+beta[2]*x
				logf3[x0,x1]<- -log(2*3.15)+log(det(T))-0.5*t(beta-theta0)%*%T%*%(beta-theta0)
		}
}





theta<-mcmc.output$b2

iter<-length(theta[,1])

lagtest<- rbind( c(0,0), theta[1:(iter-1),]) - theta

change.ind<- apply( lagtest^2, 1, sum )!=0

theta.changed<-theta[change.ind,]
iterations<-1:iter
iterations.changed<-iterations[change.ind]
index.changed<-1:length(iterations.changed)


#-------------------------------------------------------------------------------

postscript('chap1_ex07_2-1.ps', width = 10.0, height = 6.0, horizontal=FALSE)
par( xaxs='r', yaxs='r', bty='l' , cex=0.8)

contour(b0,b1,exp(logf),col=3, xlim=c(-2.0,6), ylim=c(-0.7,0.1), xlab='beta0', ylab='beta1')

contour(b0,b1,exp(logf3), add=TRUE, col=2)

maxiter<-100
temp<-index.changed[iterations.changed>=maxiter]

maxiter<-temp[1]-1
step<-2

index<-seq(1,maxiter,step) # 100 iterations
index2<-c(index,maxiter+1)

arrows( c(0,theta.changed[index,1]) ,c(0,theta.changed[index,2]), theta.changed[index2,1] , theta.changed[index2,2], , length=0.1 , angle=20, lwd=2 )
points( c(0,theta.changed[index2,1]) , c(0,theta.changed[index2,2]) )
text(c(0,theta.changed[index2,1])+0.010, c(0,theta.changed[index2,2])+0.025, c(0,iterations.changed[index2]), cex=1.0)
graphics.off()


#-------------------------------------------------------------------------------

postscript('chap1_ex07_2-2.ps', width = 10.0, height = 6.0, horizontal=FALSE)
par( xaxs='r', yaxs='r', bty='l' , cex=0.8)

contour(b0,b1,exp(logf),col=3, xlim=c(0,6), ylim=c(-0.6,0.1), xlab='beta0', ylab='beta1')

contour(b0,b1,exp(logf3), add=TRUE, col=2)

maxiter<-1000
temp<-index.changed[iterations.changed>=maxiter]

maxiter<-temp[1]-1
step<-10

index<-seq(1,maxiter,step) # 100 iterations
index2<-c(index,maxiter+1)

arrows( c(0,theta.changed[index,1]) ,c(0,theta.changed[index,2]), theta.changed[index2,1] , theta.changed[index2,2], , length=0.1 , angle=20, lwd=2 )
points( c(0,theta.changed[index2,1]) , c(0,theta.changed[index2,2]) )
text(c(0,theta.changed[index2,1])+0.010, c(0,theta.changed[index2,2])+0.020, c(0,iterations.changed[index2]), cex=1.0)
graphics.off()


#-------------------------------------------------------------------------------
postscript('chap1_ex07_2-3.ps', width = 10.0, height = 6.0, horizontal=FALSE)
par( xaxs='r', yaxs='r', bty='l' , cex=0.8)

contour(b0,b1,exp(logf),col=3, xlim=c(-1,6.5), ylim=c(-0.8,0.1), xlab='beta0', ylab='beta1')

contour(b0,b1,exp(logf3), add=TRUE, col=2)

maxiter<-10000
temp<-index.changed[iterations.changed>=maxiter]

maxiter<-temp[1]-1
step<-200

index<-seq(1,maxiter,step) # 100 iterations
index2<-c(index,maxiter+1)

arrows( c(0,theta.changed[index,1]) ,c(0,theta.changed[index,2]), theta.changed[index2,1] , theta.changed[index2,2], , length=0.1 , angle=20, lwd=2 )
points( c(0,theta.changed[index2,1]) , c(0,theta.changed[index2,2]) )
text(c(0,theta.changed[index2,1])+0.010, c(0,theta.changed[index2,2])+0.020, c(0,iterations.changed[index2]), cex=1.0)
graphics.off()






#-------------------------------------------------------------------------------
postscript('chap1_ex07_2-4.ps', width = 10.0, height = 6.0, horizontal=FALSE)
par( xaxs='r', yaxs='r', bty='l' , cex=0.8)


iter<-11000
burnin<-1000
step<-10
index4<-seq(burnin+1,iter,step)


plot( theta[index4,1], theta[index4,2] , xlim=c(-1.5,8), ylim=c(-0.9,0.2), col=3, xlab='beta0', ylab='beta1')

contour(b0,b1,exp(logf),col=1 ,add=TRUE)
contour(b0,b1,exp(logf3), add=TRUE, col=2)

graphics.off()

